// Copyright© 2019 HP Development Company, L.P.
// Subject to the Terms of Use on the HP Developer's Portal at https://developers.hp.com/terms
// SPDX-License-Identifier: MIT
var token = null;
var resData = new Array();
var scimFilter;
document.onreadystatechange = function() {
	if (document.readyState === "complete") {

		token = getCookie("accessToken");
		
		// Empty Filter
		addOption( "None", "None")
		
		// Filter for devices enrolled  Yesterday
		var filterStr = buildSCIMFilter(3);
		addOption( filterStr, "Yesterday")
		
		// Filter for devices enrolled in last 30 days
		var filterStr = buildSCIMFilter(30);
		addOption( filterStr, "Last 30 days")
		
		// Filter for devices enrolled in last 30 days
		var filterStr = buildSCIMFilter(368);
		addOption( filterStr, "Last 365 Days")
		var loader = document.getElementById("loader");
		loader.style.display = "none";
	}
}

function getCookie(name) {
	var value = "; " + document.cookie;
	var parts = value.split("; " + name + "=");
	if (parts.length == 2)
		return parts.pop().split(";").shift();
}

function setFilter(){
	scimFilter = document.getElementById("input").value;
}

function addOption( value, text){
	var filter = document.getElementById( 'filter' );
	var option = document.createElement('option');
	option.value = value;
	option.innerHTML = text;
	filter.appendChild(option);
}

function buildSCIMFilter(days){
	var today = new Date();
	today.setDate(today.getDate()-days);
	today.setHours(0,0,0,0);
	var dd = today.getDate();
	var mm = today.getMonth() + 1; //January is 0!
	var yyyy = today.getFullYear();
	if (dd < 10) {
	  dd = '0' + dd;
	}
	if (mm < 10) {
	  mm = '0' + mm;
	}
	today = yyyy + '-' + mm + '-' + dd + 'T00:00:00Z';
	return 'datelistMonth gt "' + today + '"';
}

function getData() {
	var loader = document.getElementById("loader");
	loader.style.display = "block";
	document.getElementById( 'container' ).innerHTML = '';
	document.getElementById("message").innerHTML = '';
	var data;
	var xhr = new XMLHttpRequest();
	xhr.withCredentials = true;
	xhr.addEventListener("readystatechange", function() {
		if (this.readyState === 4) {
			var res = JSON.parse(this.responseText);
			document.getElementById("message").innerHTML="Showing 1 - "+ res.itemsPerPage +" of " + res.totalResults; 
			plotTable(res.resources);
		}
	});
	
	// Target Endpoint
	// ----------------
	// For US customer: https://daas.api.hp.com
	// For EU customers: https://eu.daas.api.hp.com
	var url = "https://daas.api.hp.com/analytics/v1/reports/hwinv/details/type/grid?count=1000";
	
	if(scimFilter != undefined && scimFilter.length > 1 && scimFilter != "None"){
		url += "&filter= " + scimFilter;
	}

	xhr.open("POST", url);
	xhr.setRequestHeader("Authorization", "Bearer " + token);
	xhr.send(data);
}

function plotTable(data) {
	var div = document.getElementById( 'container' );
	div.innerHTML = '';
	var html = "<table id='app-data'>";

	html += "<tr>" + 
	"<th>Enrolled Month</th>" + 
	"<th>Device Name</th>" + 
	"<th>Serial Number</th>" + 
	"<th>Device Type</th>" + 
	"<th>Device Manufacturer</th>" + 
	"<th>Device Model</th>" + 
	"<th>Operating System</th>" + 
	"<th>Operating System Release</th>" + 
	"<th>Operating System Build No.</th>" + 
	"<th>Windows 10 Patch Status</th>" + 
	"<th>Last Seen</th>" + 
	"<th>Memory</th>" + 
	"<th>Graphics</th>" + 
	"<th>Processor</th>" + 
	"<th>Manufacture Date</th>" + 
	"<th>Enrolled Date</th>" + 
	"<th>Warranty Status</th>" +
	"<th>Warranty End Date</th>" + 
	"</tr>";

	for (var i = 0; i < data.length; i++) {
		html += "<tr>";
		html += "<td>" + data[i].dateListMonth + "</td>";
		html += "<td>" + data[i].deviceName + "</td>";
		html += "<td>" + data[i].deviceSn + "</td>";
		html += "<td>" + data[i].deviceType + "</td>";
		html += "<td>" + data[i].deviceMfg + "</td>";
		html += "<td>" + data[i].deviceModel + "</td>";
		html += "<td>" + data[i].deviceOsOriginal + "</td>";
		html += "<td>" + data[i].osrelease + "</td>";
		html += "<td>" + data[i].osversion + "</td>";
		html += "<td>" + data[i].osStatus + "</td>";
		html += "<td>" + data[i].lastOnlineDate + "</td>";
		html += "<td>" + data[i].memory + "</td>";
		html += "<td>" + data[i].graphics + "</td>";
		html += "<td>" + data[i].processor + "</td>";
		html += "<td>" + data[i].mfgDate + "</td>";
		html += "<td>" + data[i].dateEnrolled + "</td>";
		html += "<td>" + data[i].warStatus + "</td>";
		html += "<td>" + data[i].endDate + "</td>";
		html += "</tr>";
	}
	html += "</table>";
	div.innerHTML = html ;
	var loader = document.getElementById("loader");
	loader.style.display = "none";
}